
var SDKNativeSucEvents = {};
var SDKNativeFailEvents = {};

function sdk_launchFunc(funcName,data,SucCallback,FailCallback){
    var newName = funcName += getUniqueKey();
    SDKNativeSucEvents[newName] = SucCallback;
    SDKNativeFailEvents[newName] = FailCallback;
    var toJavaData = null;
    if(data != null && data != ""){
        toJavaData = JSON.stringify(data);
    }
    window.DY.DY_Func(newName,toJavaData,true);
}

function adk_listenerFunc(funcName,SucCallback){
    SDKNativeSucEvents[funcName] = SucCallback;
}
function sdk_removeListenerFunc(funcName){
    SDKNativeSucEvents[funcName] = null;
    delete SDKNativeSucEvents[funcName];
}
function sdk_nativeCallback_Suc(funcName,data,isListener){
    var obj = null;
    if(data != null && data != ""){
        obj = JSON.parse(data);
    }
    try{
        if(SDKNativeSucEvents[funcName] != "null" && SDKNativeSucEvents[funcName] != "undefined" && SDKNativeSucEvents[funcName]){
            SDKNativeSucEvents[funcName](obj);
            if(isListener == "false"){
                SDKNativeSucEvents[funcName] = null;
                SDKNativeFailEvents[funcName] = null;
                delete SDKNativeSucEvents[funcName];
                delete SDKNativeFailEvents[funcName];
            }
        }
    }catch(e){
        alert(e);
    }
}

function sdk_nativeCallback_Fail(funcName,data,isListener){
   var obj = null;
    if(data != null && data != ""){
        obj = JSON.parse(data);
    }
    try{
        if(SDKNativeFailEvents[funcName] != "null" && SDKNativeFailEvents[funcName] != "undefined" && SDKNativeFailEvents[funcName]){
            SDKNativeFailEvents[funcName](obj);
            if(isListener == "false"){
                SDKNativeFailEvents[funcName] = null;
                SDKNativeSucEvents[funcName] = null;
                delete SDKNativeSucEvents[funcName];
                delete SDKNativeFailEvents[funcName];
            }
        }
    }catch(e){
        alert(e);
    }
}

var chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];

function randomStr() {
    var res = "";
    for(var i = 0; i < 5; i++) {
        var id = Math.ceil(Math.random() * 35);
        res += chars[id];
    }
    return res;
}

function getUniqueKey(){
    return randomStr()+""+(new Date()).getTime();
}

function getStyleData(data){
    if(data == null || data == "" || data == "undefined"){
       data = {};
       data.style = {};
    }else if(data.style == null || data.style == "" || data.style == "undefined"){
       data.style = {};
    }
    return data;
}
window.DY.getSystemInfo = function(data) {
    sdk_launchFunc("getSystemInfo", null, data.success,data.fail);
};
window.DY.requestScreenOrientation = function(data) {
    sdk_launchFunc("requestScreenOrientation", data, data.success,data.fail);
};
window.DY.setKeepScreenOn = function(data) {
    sdk_launchFunc("setKeepScreenOn", null, data.success,data.fail);
};
window.DY.loginDY = function(data) {
    sdk_launchFunc("loginDY", null, data.success,data.fail);
};
window.DY.getMenuStyle = function(data) {
    sdk_launchFunc("getMenuStyle", null, data.success,data.fail);
};
window.DY.wxLogin = function(suc,fail) {
   sdk_launchFunc("wxLogin", null, suc,fail);
};
window.DY.createBannerAd = function(data) {
     var dataStyle = getStyleData(data);
     var style = dataStyle.style;
    var androidBannerObject = window.DY.initBanner(style.gravity, style.height, style.width,style.x,style.y,style.adIntervals);
      androidBannerObject.onShow = function(data){
           adk_listenerFunc("showBannerFun", data);
        };
        androidBannerObject.onHide = function(data){
          adk_listenerFunc("hideBannerFun", data);
       };
        androidBannerObject.onErr = function(data){
          adk_listenerFunc("errorBannerFun", data);
       };
    return androidBannerObject;
};
window.DY.createInfoStreamAd = function(data) {
   var dataStyle = getStyleData(data);
   var style = dataStyle.style;
   var androidInfoStream = window.DY.initInfoStream(style.x,style.y, style.height, style.width);
   androidInfoStream.onShow = function(data){
      adk_listenerFunc("showInfoFun", data);
   };
   return androidInfoStream;
};
window.DY.createRewardVideoAd = function(data) {
   var androidRewardAd = window.DY.initRewardVideoAd(data[0],data[1], data[2]);
   androidRewardAd.onClose = function(data){
      adk_listenerFunc("videoCloseFun", data);
   };
   androidRewardAd.onLoad = function(data){
         adk_listenerFunc("videoLoadFun", data);
      };
   androidRewardAd.onError = function(data){
        adk_listenerFunc("videoErrorFun", data);
     };
   return androidRewardAd;
};

window.DY.uploadResult = function(resultType,suc,fail) {
   sdk_launchFunc("uploadResult", resultType, suc,fail);
};

window.DY.showAlert = function(data) {
   sdk_launchFunc("showAlert", data, data.onEnter,data.onCancel);
};
window.DY.gameOutAlert = function(onEnter,onCancel) {
   sdk_launchFunc("gameOutAlert",null,onEnter,onCancel);
};
window.DY.showResultUI = function(data) {
   sdk_launchFunc("showResultUI", data, data.onAgain,data.onExit);
};
window.DY.onShow = function(data) {
    adk_listenerFunc("onShow", data);
};
window.DY.onHide = function(data) {
    adk_listenerFunc("onHide", data);
};
window.DY.isFighting = false;


window.DY.getGameRoomData = function(data) {
    sdk_launchFunc("getGameRoomData", data, data.success,data.fail);
};
window.DY.sendData = function(data) {
    sdk_launchFunc("sendData", data, data.success,data.fail);
};
window.DY.gameStart = function(data) {
    adk_listenerFunc("gameStart", data);
};
window.DY.gameOver = function(data) {
    adk_listenerFunc("gameOver", data);
};
window.DY.synchronizeData = function(data) {
    adk_listenerFunc("synchronizeData", data);
};
window.DY.roomServiceReady = function(data) {
    adk_listenerFunc("roomServiceReady", data);
};
window.DY.addAchievement = function(data) {
    sdk_launchFunc("addAchievement", data, data.success,data.fail);
};
window.DY.getScreenInfo = function(data) {
    sdk_launchFunc("getScreenInfo", data, data.success,data.fail);
};
window.DY.setVibrate = function(data) {
    sdk_launchFunc("setVibrate", data, data.success,data.fail);
};
window.DY.getMultiplayerUserData = function(data) {
    sdk_launchFunc("getMultiplayerUserData", data, data.success,data.fail);
};
window.DY.queryRelation = function(data) {
    sdk_launchFunc("queryRelation", data, data.success,data.fail);
};
window.DY.toReport = function(data) {
    sdk_launchFunc("toReport", data, data.success,data.fail);
};
window.DY.useInputText = function(data) {
    sdk_launchFunc("useInputText", data, data.success,data.fail);
};
window.DY.exitGame = function(data) {
    sdk_launchFunc("exitGame", data, data.success,data.fail);
};
window.DY.uploadScore = function(data) {
    sdk_launchFunc("uploadScore", data, data.success,data.fail);
};
window.DY.multiplayerVoice = function(data) {
    sdk_launchFunc("multiplayerVoice", data, data.success,data.fail);
};
window.DY.hideKeyboard = function(data) {
    sdk_launchFunc("hideKeyboard", data, data.success,data.fail);
};



